/* copyright  by Stefan Voitel, 2003 - all rights reserved                   */
/* eMail : stefan.voitel@winways.de                                           */

#include "cAgent.h"
#include "cAgentSink.h"

// ****************************************************************************
// sink callbacks
// ****************************************************************************
#pragma warning (push)
#pragma warning (disable : 4100)

#if defined (__BORLANDC__)
#pragma argsused
#endif
STDMETHODIMP cAgentSink::Click (long dwCharID,short fwKeys,long X,long Y) {
Agent->Click ((cAgent::teMouseEventKeys) fwKeys,
                        (cAgent::tMousePosition) MAKELONG((short)X,(short)Y));
return NOERROR;
}
#if defined (__BORLANDC__)
#pragma argsused
#endif

STDMETHODIMP cAgentSink::DblClick (long dwCharID,short fwKeys,long X,long Y) {
Agent->DblClick ((cAgent::teMouseEventKeys) fwKeys,
                        (cAgent::tMousePosition) MAKELONG((short)X,(short)Y));
return NOERROR;
}
#if defined (__BORLANDC__)
#pragma argsused
#endif

STDMETHODIMP cAgentSink::BookMark (long dwBookMarkID) {
Agent->BookMark ((cAgent::tBookMarkID) dwBookMarkID);
return NOERROR;
}
#if defined (__BORLANDC__)
#pragma argsused
#endif

STDMETHODIMP cAgentSink::RequestComplete (long dwRequestID,long hrStatus) {
Trigger = true;
return NOERROR;
}

#pragma warning (pop)
// *****************************************************************************
// constructor / destructor
// *****************************************************************************
cAgentSink::cAgentSink (cAgent* a) :
            Agent(a) , Trigger(true) , ExecThreadHasInitialized(false) {
   
AddRef ();

DWORD tid;
ExecThreadHandle = CreateThread (NULL,0,ExecThread,(void*) this,0,&tid);

if (ExecThreadHandle == NULL)
   throw "cAgentSink::cAgentSink() fails, condition : CreateThread";

DWORD fails = GetTickCount() +10000;

while (! ExecThreadHasInitialized) {
   
   if (GetTickCount() > fails) {
      TerminateThread (ExecThreadHandle,0xFFFFFFFA);
      throw "cAgentSink::cAgentSink() fails, condition : Thread timeout";
      }
   Sleep (100);
   }
}

cAgentSink::~cAgentSink () {
DWORD ExitCode , Count = 0;

do {
   Sleep (100);
   GetExitCodeThread (ExecThreadHandle,&ExitCode);
   } while (ExitCode == STILL_ACTIVE && Count < 100);
   
if (ExitCode == STILL_ACTIVE)
   TerminateThread (ExecThreadHandle,0xFFFFFFFB);
   
Release();   
}

// ****************************************************************************
// Thread
// ****************************************************************************
DWORD WINAPI cAgentSink::ExecThread (void *SinkObject) {
cAgentSink *S =  (cAgentSink*) SinkObject;
cAgent     *A = ((cAgentSink*) SinkObject)->Agent;

A->FromSinkThread_Init();
A->iAgentEx->Register((IUnknown*) S,&A->SinkID);

S->ExecThreadHasInitialized = true;

while (! A->Terminate) {

   if (S->Trigger) {
      char *Command = S->Get();
   
      if (Command != NULL ) {
         S->Trigger = A->FromSinkThread_Command (Command);
         S->Pop();
         }
      }

   A->FromSinkThread_CheckStop ();
      
   MSG msg;
   while (! A->Terminate && PeekMessage (&msg,NULL,0,0,PM_REMOVE)) {
      DispatchMessage (&msg);
      }

   Sleep (1);
   }
   
if (! IsBadCodePtr ((FARPROC) A->iAgentEx)) {
   if (A->SinkID != -1 && A->iAgentEx)
      A->iAgentEx->Unregister (A->SinkID);
   }
   
A->FromSinkThread_Free();         
return 0;   
}

// ****************************************************************************
//  iUnknown && iDispatch
// ****************************************************************************
STDMETHODIMP cAgentSink::QueryInterface (REFIID riid,LPVOID *ppv) {
HRESULT Result = E_NOINTERFACE;
*ppv           = NULL;

if ((riid == IID_IUnknown) || (riid == IID_IAgentNotifySink)) {
   if ((*ppv = this) != NULL) {
      Result = NOERROR;
      ((LPUNKNOWN)*ppv)->AddRef();
      }
   }
return Result;
}

STDMETHODIMP_(ULONG) cAgentSink::AddRef() {
return ++RefCount;
}

STDMETHODIMP_(ULONG) cAgentSink::Release() {
if (--RefCount == 0) {
   delete this;
   return 0;
   }
return RefCount;
}

STDMETHODIMP cAgentSink::GetTypeInfoCount(UINT *pctInfo) {
*pctInfo = 1;
return NOERROR;
}

STDMETHODIMP cAgentSink::GetTypeInfo(UINT itInfo,LCID lcid,ITypeInfo **ppTypeInfo) {
HRESULT hRes;
ITypeLib *pLib;

*ppTypeInfo = NULL;

if (itInfo == 0) {
   if (ppTypeInfo != NULL) {
      if ((PRIMARYLANGID (lcid) == LANG_NEUTRAL) || 
                                       (PRIMARYLANGID (lcid) == LANG_ENGLISH)) {
         
         hRes = LoadRegTypeLib (LIBID_AgentServerObjects,1,0,
                                                     PRIMARYLANGID(lcid),&pLib);
         if (SUCCEEDED (hRes)) {
            hRes = pLib->GetTypeInfoOfGuid(IID_IAgentNotifySink, ppTypeInfo);
            pLib->Release();

            if (SUCCEEDED (hRes)) {
               (*ppTypeInfo)->AddRef();
               hRes = NOERROR;
               }
            }            
         }      
      else hRes = DISP_E_UNKNOWNLCID;
      }
   else hRes = E_POINTER;
   }
else hRes = TYPE_E_ELEMENTNOTFOUND;

return hRes;
}

STDMETHODIMP cAgentSink::GetIDsOfNames(REFIID riid,OLECHAR **rgszNames,
                                       UINT cNames,LCID lcid,DISPID *rgDispID) {
HRESULT hRes;
ITypeInfo *pInfo;

if (riid == IID_NULL) {
   if (SUCCEEDED (hRes = GetTypeInfo(0, lcid, &pInfo))) {
      hRes = pInfo->GetIDsOfNames(rgszNames, cNames, rgDispID);
      pInfo->Release();
      }
   }   
else hRes = ResultFromScode(DISP_E_UNKNOWNINTERFACE);
return hRes;
}

STDMETHODIMP cAgentSink::Invoke (DISPID dispID, REFIID riid,LCID lcid,USHORT wFlags,
            						         DISPPARAMS *pDispParams, VARIANT *pVarResult,
            						              EXCEPINFO *pExcepInfo,UINT *puArgErr) {
HRESULT hRes;
ITypeInfo *pInfo;

if (riid == IID_NULL) {
   if (SUCCEEDED(hRes = GetTypeInfo(0,lcid,&pInfo))) {
      SetErrorInfo(0L,NULL);
      hRes = pInfo->Invoke (this,dispID,wFlags,pDispParams,pVarResult,
                                                   pExcepInfo,puArgErr);
      pInfo->Release();
      }
   }   
else hRes = DISP_E_UNKNOWNINTERFACE;   
return hRes;
}
// EOF